#include <pybind11/pybind11.h>
#include <pybind11/stl.h>
#include <GLFW/glfw3.h>

int pytest_glfw_window()
{
    GLFWwindow* window;

    /* Initialize the library */
    if (!glfwInit())
        return -1;

    /* Create a windowed mode window and its OpenGL context */
    window = glfwCreateWindow(640, 480, "Hello World", NULL, NULL);
    if (!window)
    {
        glfwTerminate();
        return -1;
    }

    /* Make the window's context current */
    glfwMakeContextCurrent(window);

    /* Loop until the user closes the window */
    while (!glfwWindowShouldClose(window))
    {
        /* Render here */
        glClear(GL_COLOR_BUFFER_BIT);

        /* Swap front and back buffers */
        glfwSwapBuffers(window);

        /* Poll for and process events */
        glfwPollEvents();
    }

    glfwTerminate();
    return 0;
}



PYBIND11_MODULE(glpy, m) {
    m.doc() = "glpy a python opengl project"; // optional module docstring
    m.def("pytest_glfw_window",pytest_glfw_window);
}